% ressort09.m          
%              deux oscillateurs couples equation adjointe 
%                                      calcul du gradient  
% fd  6 avril 2005, 08 janvier 2006, 09, 10 mars, 13, 14  mai 2006 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
title ('Assimilation variationnelle pour deux  oscillateurs harmoniques couples') ;
nitmax = 40     %                  nombre d iterations du gradient  
roro   = .005     %                  parametre de sous-relaxation
n=100            %                  nombre de points en temps 
tmax= 10        %                  temps d assimilation des donnees
%
%                               parametres initiaux 
  kkini1 = .2 ; kkini2 = 3 ;  kka1 = kkini1 ; kka2 = kkini2 ;
%  kkini1 = 3 ; kkini2 = .2 ;  kka1 = kkini1 ; kka2 = kkini2 ;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%       donnes de reference      %%%%%%%%%%%%
mm1 = 1 ; mm2 = 1 ; mm3 = 1 ;  kk1 = 1 ; kk2 = 2 ; 
mm=[ mm1 0 0 ; 0  mm2 0 ; 0 0  mm3 ]  ; 
z3 = [  0  0 0 ; 0  0  0 ; 0 0  0 ] ;  cc= z3 ; 
ggkk1 = [ 1 -1 0 ; -1 1 0 ; 0 0 0 ] ; 
ggkk2 = [ 0 0 0 ;  0 1 -1 ; 0 -1 1 ] ; 
kk    = kk1 * ggkk1 +  kk2 * ggkk2 ; 
x0 = [ 1 -1  0 ]' ;
y0 = [ 0 0 1 ]' ;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%       solution analytique     %%%%%%%%%%%%
I3 = [  1  0 0 ; 0  1  0 ; 0 0  1 ] ; 
aa = [ z3 , I3 ; -mm\kk , z3  ] ;  
u0 = [ x0 ; y0 ] ; 
uf = expm(tmax*aa)*u0 ; 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%       solution numerique     %%%%%%%%%%%%

dt=tmax/n ; 
t=zeros(1,n+1);
td=zeros(1,n);
x=zeros(3,n+1);
y=zeros(3,n+1); 
%
x(:,1:1) = x0 ; 
y(:,1:1) = y0 ; 
xx = x0 ;
yy = y0 ;
ga = -mm \ (cc * yy + kk*xx)  ;
ss = mm + .5*dt*cc + .25*dt*dt*kk ; 
for i=1:n;
t(i+1)=t(i)+dt;
td(1,i:i) = (i-.5)*dt ; 
end ; 
for i=1:n;
xt = xx + dt*yy + .25*dt*dt*ga ; 
yt = yy + .5*dt * ga ; 
ga = ss \ ( - kk*xt - cc*yt ) ;
xx = xt + .25*dt*dt*ga ; 
yy = yt + .5*dt*ga ; 
%
x(:,i+1:i+1) = xx ;  
y(:,i+1:i+1) = yy ; 
end ;
%                        solution analytique
uuu=zeros(6,n+1); 
for i=1:n+1;
uuu(:,i:i)  = expm(t(i)*aa)*u0 ; end 


xmax=tmax+.1 ; 
axis ( [ -.1   , xmax  , -10.1 , 10.1 ]) ;
plot(  t(1,:) , x(1:1,:), '*;;' ,    t(1,:) , uuu(1:1,:), 'r;;' ,  \
t(1,:) , x(2:2,:), '*b;;' ,   t(1,:) , uuu(2:2,:), 'b;;' ,  \ 
t(1,:) , x(3:3,:), '*g;;' ,   t(1,:) , uuu(3:3,:), 'g;;' ,  \ 
t(1,:) , mm1*x(1:1,:) + mm2*x(2:2,:) + mm3*x(3:3,:) , '*m;;' , \
t(1,:) , mm1*uuu(1:1,:) + mm2*uuu(2:2,:) + mm3*uuu(3:3,:) , 'm;;' ) ; 
pause

%                                     initialisation
 lll=0 ; 
kkas = zeros (2,nitmax+1) ;   jiter =  zeros (1,nitmax+1) ; 
jiter  (1,lll+1:lll+1)  = lll ; 
kkas (1:1,lll+1:lll+1) = kka1 ; 
kkas (2:2,lll+1:lll+1) = kka2 ; 
masse=mm ; amort=cc;  ; 
raideur= kka1 * ggkk1 +  kka2 * ggkk2 ; 

%                               boucle en les parametres 
for lll = 1:nitmax ; lll ; 
xxs=zeros(3,n+1);
yys=zeros(3,n+1); 
%                               evolution directe
xxx = x0 ;
yyy = y0 ; 
xxs(:,1:1)=xxx ; 
yys(:,1:1)=yyy ; 
ssiter = masse + .5*dt*amort + .25*dt*dt*raideur ; 
for i=1:n;
ga = -masse \ ( raideur*xxx + amort*yyy )  ;
xt = xxx + dt*yyy + .25*dt*dt*ga ;
yt = yyy + .5*dt * ga ; 
ga = ssiter \ ( - raideur*xt - amort*yt ) ;
xxx  = xt + .25*dt*dt*ga ; 
yyy  = yt + .5*dt*ga ; 
xxs(:,i+1:i+1)  = xxx ;  
yys(:,i+1:i+1)  = yyy ; 
end ; 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                     solution analytique et comparaison 
if (lll==1)  ; 
aa = [ z3 , I3 ; -masse\raideur , z3  ] ;  
u0 = [ x0 ; y0 ] ; 
uf = expm(tmax*aa)*u0 ; 
uuu=zeros(6,n+1); 
for i=1:n+1;
uuu(:,i:i)  = expm(t(i)*aa)*u0 ; end 
xmax=tmax+.1 ; 
axis ( [ -.1   , xmax  , -10.1 , 10.1 ]) ;
plot(  t(1,:) , xxs(1:1,:), '*;;' ,    t(1,:) , uuu(1:1,:), 'r;;' ,  \
t(1,:) , xxs(2:2,:), '*b;;' ,   t(1,:) , uuu(2:2,:), 'b;;' ,  \ 
t(1,:) , xxs(3:3,:), '*g;;' ,   t(1,:) , uuu(3:3,:), 'g;;' ,  \ 
t(1,:) , mm1*xxs(1:1,:) + mm2*xxs(2:2,:) + mm3*xxs(3:3,:) , '*m;;' , \
t(1,:) , mm1*uuu(1:1,:) + mm2*uuu(2:2,:) + mm3*uuu(3:3,:) , 'm;;' ) ; 
pause ;    end ; 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%                                   erreur
err = xxs - x ; 
if ((lll==1)|(lll==nitmax))  ; 
axis ( [ -.1   , tmax+ .1   , -1.1 , 1.1 ]) ;
plot ( t(1,:) , err(1:1,:), '*;erreur;' , t(1,:) , err(2:2,:), '*b;;' , \
       t(1,:) , err(3:3,:), '*g;;'   ) ; pause  ; end ; 

%                                                equation adjointe
ss = masse + .5*dt*amort + .25*dt*dt*raideur ; 
pp = zeros(3,n); qq = pp ; 
pp(:,n:n) = .5 * dt * err(:,n+1:n+1) ; 
qq(:,n:n) = 0 ; 
ymax = abs(pp(:, n:n)) ; 
ymax = max (ymax(:),abs(qq(:,n:n))) ; 
for j = 1:n-1;
jj    = n-j ; 
ro    = -ss \ (.25*dt*dt*pp(:,jj+1:jj+1) + .5*dt*qq(:,jj+1:jj+1) ) ; 
pt    = pp(:,jj+1:jj+1) + raideur*ro ; 
qt    = qq(:,jj+1:jj+1) + amort*ro ; 
rot   = - masse \ (.25*dt*dt*pt + .5*dt*qt ) ;
pp(:,jj:jj) = pt + dt*err(:,jj+1:jj+1) + raideur*rot ; 
qq(:,jj:jj) = qt + dt*pt               + amort*rot ; 
ymax = max (ymax(:),abs(pp(:,jj:jj))) ; 
ymax = max (ymax(:),abs(qq(:,jj:jj))) ; 
end ;

ymax = max(ymax(:)) ; ymax = 1.05 * ymax ;

if ((lll==1)|(lll==nitmax))  ; 
axis ( [ -.1   , tmax+.3  , -ymax  , ymax  ] ) ;
plot (  td(1,:) , pp(1:1,:), '*;premier etat adjoint;',   \ 
        td(1,:) , qq(1:1,:), 'r;etat adjoint de la derivee;'  ,  \
        td(1,:) , pp(2:2,:), '*b;;' , \
        td(1,:) , qq(2:2,:), 'b;;'  ,  \
        td(1,:) , pp(3:3,:), '*g;;' , \
        td(1,:) , qq(3:3,:), 'g;;'    ) ; pause  ; end ; 
%
%                          gradient par rapport a kka1 et kka2
grkka1 = 0 ;  grkka2 = 0 ; 
for  j = 1:n ;
xxx    = xxs(:,j:j) ; 
yyy    = yys(:,j:j) ; 
ga     = -masse \ ( raideur*xxx + amort*yyy )  ;
xt     = xxx + dt*yyy + .25*dt*dt*ga ;
yt     = yyy + .5*dt * ga ; 
gap    = ss \ ( - raideur*xt - amort*yt ) ;
ro     = -ss \ (.25*dt*dt*pp(:,j:j) + .5*dt*qq(:,j:j) ) ; 
pt     = pp(:,j:j) + raideur*ro ; 
qt     = qq(:,j:j) + amort*ro ; 
rot    = - masse \ ( .25*dt*dt*pt + .5*dt*qt ) ;
grkka1 = grkka1 + ro'*ggkk1*(xt+dt*dt*gap/4) + rot'*ggkk1*xxx ; 
grkka2 = grkka2 + ro'*ggkk2*(xt+dt*dt*gap/4) + rot'*ggkk2*xxx ;  
end ; 

%   grkka1 , grkka2 
kka1   = kka1  - roro * grkka1 ; 
kka2   = kka2  - roro * grkka2 ; 
raideur= kka1 * ggkk1 +  kka2 * ggkk2 ; 

jiter  (1,lll+1:lll+1,1)  = lll ; 
kkas (1:1,lll+1:lll+1) = kka1 ; 
kkas (2:2,lll+1:lll+1) = kka2 ; 

end ; 


zzmm = max (kka1 , kkini1) ; zzmm = max (zzmm , kka2 ) ; 
zzmm = max (zzmm , kkini2) ;  zzmm = 1.05 * zzmm ; 
zmin = min( kkini1 , kkini2) ; zmin = min(zmin , kk1) ; zmin = min(zmin , kk2) ; 
% axis ( [ -.5   , nitmax+.5  , .90*zmin  , zzmm  ] ) ;
axis ( [ -.5   , nitmax+.5  , -.1  , zzmm  ] ) ;
plot ( jiter(1,:) , kkas (1:1,:) ,   '*;raideur1;' ,  \
       [0 , nitmax] , [kk1 , kk1] , 'r;;' ,\ 
       jiter(1,:) , kkas (2:2,:) ,  '*b;raideur2;' ,  \
       [0 , nitmax] , [kk2 , kk2] , 'b;;')



