% ressort07.m
% fd  6 avril 2005, 08 janvier 2006, 09, 10 mars, 13 mai 2006 
% fd  01 mars 2025  
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% title ('precision du Newmark dans le cas non amorti') ;
mm1 = 1 ; mm2 = 1 ; mm3 = 1 ;  kk1 = 1 ; kk2 = 2 ; 
mm=[ mm1 0 0 ; 0  mm2 0 ; 0 0  mm3 ]  ; 
cc=[ 0  0 0 ; 0  0  0 ; 0 0  0 ] ; 
kk=[ kk1 -kk1 0 ; -kk1 kk1+kk2 -kk2 ; 0 -kk2 kk2 ] ; 
x0 = [ 1 -1  0 ]' ;
y0 = [ 0 0 1 ]' ;
tmax= 10 ; 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%       solution analytique     %%%%%%%%%%%%
z3 = [  0  0 0 ; 0  0  0 ; 0 0  0 ] ; 
I3 = [  1  0 0 ; 0  1  0 ; 0 0  1 ] ; 
aa = [ z3 , I3 ; -mm\kk , z3  ] ;  
u0 = [ x0 ; y0 ] ; 
uf = expm(tmax*aa)*u0 ; 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%       solution numerique     %%%%%%%%%%%%
m=6
pas=zeros(m,1);
err=zeros(m,1);
%

n = 32 
for j=1:m; %%%%%%%%%%%%%%%    debut de la boucle sur les maillages
%%% disp ('n = ',n)  
dt=tmax/n ; 
t=zeros(1,n+1);
x=zeros(3,n+1);
y=zeros(3,n+1); 

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%       solution analytique au cours du temps      %%%%%%%%%%%%
for i=1:n;
t(i+1)=t(i)+dt;
end ;

xex=zeros(3,n+1);
yex=zeros(3,n+1); 

for i=1:n+1;
ttt = t(i) ; 
ut = expm(ttt*aa)*u0 ;
xex(1,i:i) = ut(1) ; xex(2,i:i) = ut(2) ; xex(3,i:i) = ut(3) ;
yex(1,i:i) = ut(4) ; yex(2,i:i) = ut(5) ; yex(3,i:i) = ut(6) ;
end 



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%       solution numerique     %%%%%%%%%%%%
xx = x0 ;
yy = y0 ;
ga = -mm \ (cc * yy + kk*xx)  ;
ss = mm + .5*dt*cc + .25*dt*dt*kk ; 


x(:,1:1) = x0(:,1) ; 
y(:,1:1) = y0(:,1) ; 
for i=1:n;
xt = xx + dt*yy + .25*dt*dt*ga ; 
yt = yy + .5*dt * ga ; 
ga = ss \ ( - kk*xt - cc*yt ) ;
xn = xt + .25*dt*dt*ga ; 
yn = yt + .5*dt*ga ; 
%
x(:,i+1:i+1) = xn(:,1) ; 
y(:,i+1:i+1) = yn(:,1) ; 
xx(:,1) = x(:,i+1:i+1) ; 
yy(:,1) = y(:,i+1:i+1) ; 
end ;
xmax=tmax+.1 ;

hold off 
if n==32 ;
plot(t(1,:) , x(1:1,:), '*k;x1 position;' , t(1,:) , xex(1:1,:), 'k;;'  , ... 
     t(1,:) , x(2:2,:), '*b;x2 position;' , t(1,:) , xex(2:2,:), 'b;;'  , ...
     t(1,:) , x(3:3,:), '*r;x3 position;' , t(1,:) , xex(3:3,:),  'r;;' , ....
     t(1,:) , y(1:1,:), 'ok;y1 impulsion;' , t(1,:) , yex(1:1,:), 'k;;' , ...
     t(1,:) , y(2:2,:), 'ob;y2 impulsion;' , t(1,:) , yex(2:2,:), 'b;;' , ...
     t(1,:) , y(3:3,:), 'or;y3 impulsion;' , t(1,:) , yex(3:3,:), 'r;;') 
axis ( [ -.1   , xmax  , -1.9 , 6.1 ]) ;
title ('triple oscillateur harmonique non amorti ; schema de Newmark, n=32') ; 
print('07-032-iterations-newmark.jpg', '-djpg', '-S891,630'); end


if n==64 ;
plot(t(1,:) , x(1:1,:), '*k;x1 position;' , t(1,:) , xex(1:1,:), 'k;;'  , ... 
     t(1,:) , x(2:2,:), '*b;x2 position;' , t(1,:) , xex(2:2,:), 'b;;'  , ...
     t(1,:) , x(3:3,:), '*r;x3 position;' , t(1,:) , xex(3:3,:),  'r;;' , ....
     t(1,:) , y(1:1,:), 'ok;y1 impulsion;' , t(1,:) , yex(1:1,:), 'k;;' , ...
     t(1,:) , y(2:2,:), 'ob;y2 impulsion;' , t(1,:) , yex(2:2,:), 'b;;' , ...
     t(1,:) , y(3:3,:), 'or;y3 impulsion;' , t(1,:) , yex(3:3,:), 'r;;') 
axis ( [ -.1   , xmax  , -1.9 , 6.1 ]) ;
title ('triple oscillateur harmonique non amorti ; schema de Newmark, n=64') ; 
print('07-064-iterations-newmark.jpg', '-djpg', '-S891,630'); end

if n==128 ;
plot(t(1,:) , x(1:1,:), '*k;x1 position;' , t(1,:) , xex(1:1,:), 'k;;'  , ... 
     t(1,:) , x(2:2,:), '*b;x2 position;' , t(1,:) , xex(2:2,:), 'b;;'  , ...
     t(1,:) , x(3:3,:), '*r;x3 position;' , t(1,:) , xex(3:3,:),  'r;;' , ....
     t(1,:) , y(1:1,:), 'ok;y1 impulsion;' , t(1,:) , yex(1:1,:), 'k;;' , ...
     t(1,:) , y(2:2,:), 'ob;y2 impulsion;' , t(1,:) , yex(2:2,:), 'b;;' , ...
     t(1,:) , y(3:3,:), 'or;y3 impulsion;' , t(1,:) , yex(3:3,:), 'r;;') 
axis ( [ -.1   , xmax  , -1.9 , 6.1 ]) ;
title ('triple oscillateur harmonique non amorti ; schema de Newmark, n=128') ; 
print('07-128-iterations-newmark.jpg', '-djpg', '-S891,630'); end 

if n==256 ;
plot(t(1,:) , x(1:1,:), '*k;x1 position;' , t(1,:) , xex(1:1,:), 'k;;'  , ... 
     t(1,:) , x(2:2,:), '*b;x2 position;' , t(1,:) , xex(2:2,:), 'b;;'  , ...
     t(1,:) , x(3:3,:), '*r;x3 position;' , t(1,:) , xex(3:3,:),  'r;;' , ....
     t(1,:) , y(1:1,:), 'ok;y1 impulsion;' , t(1,:) , yex(1:1,:), 'k;;' , ...
     t(1,:) , y(2:2,:), 'ob;y2 impulsion;' , t(1,:) , yex(2:2,:), 'b;;' , ...
     t(1,:) , y(3:3,:), 'or;y3 impulsion;' , t(1,:) , yex(3:3,:), 'r;;') 
axis ( [ -.1   , xmax  , -1.9 , 6.1 ]) ;
title ('triple oscillateur harmonique non amorti ; schema de Newmark, n=256') ; 
print('07-256-iterations-newmark.jpg', '-djpg', '-S891,630'); end 

if n>=257 ;
plot(t(1,:) , x(1:1,:), '*k;x1 position;' , t(1,:) , x(2:2,:), '*b;x2 position;'  , ...
     t(1,:) , x(3:3,:), '*r;x3 position;' , ....
     t(1,:) , y(1:1,:), 'ok;y1 impulsion;' ,  t(1,:) , y(2:2,:), 'ob;y2 impulsion;' , ...
     t(1,:) , y(3:3,:), 'or;y3 impulsion;' )
axis ( [ -.1   , xmax  , -1.9 , 6.1 ]) ; 
title ('triple oscillateur harmonique non amorti ; schema de Newmark') ; end 


%% axis ( [ -.1   , xmax  , -10.1 , 10.1 ]) ;
%% plot(t(1,:) , x(1:1,:), '*;;' , t(1,:) , x(2:2,:), '*b;;'  , ...
%%  t(1,:) , x(3:3,:), '*g;;' ,  t(1,:) , mm1*x(1:1,:) + mm2*x(2:2,:) + mm3*x(3:3,:) , '*m;;' ) ; 
pause  (1.5) 

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%       erreur        %%%%%%%%%%%%
pas(j:j,1)=n ; 
err(j:j,1)=log ( abs( x(1:1,n+1:n+1) - uf(1:1,1) ) + ... 
 abs( x(2:2,n+1:n+1) - uf(2:2,1) ) +  abs( x(3:3,n+1:n+1) - uf(3:3,1) )  ) / log(2)  ;
if  j<m ;  n=2*n , end ; 
end 



x=zeros(m,1); x =log(pas(:,1)) / log(2) ;
y=zeros(m,1); y= err(:,1) ;
     xmax= m+4 +.1 ; 
plot( x , y ,'*;logarithme des ereurs;') ;
axis ([ 4.9 ,  xmax  ,  -11.5 , .3 ]) ;
title ('triple oscillateur harmonique non amorti ; erreurs du schema de Newmark') ; 
print('07-erreurs.jpg', '-djpg', '-S891,630'); 

%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%       pente de la droite des moindres carres  %%%%
printf ('ordre de convergence  ') 
alpha = codre(m,x,y) 








