% ressort08.m          deux oscillateurs couples equation adjointe 
% fd  6 avril 2005, 08 janvier 2006, 09, 10 mars, 13 mai 2006 
%     01 mars 2025  
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% title ('Assimilation variationnelle pour trois oscillateurs harmoniques couples') ;
mm1 = 1 ; mm2 = 1 ; mm3 = 1 ;  kk1 = 1 ; kk2 = 2 ; 
mm=[ mm1 0 0 ; 0  mm2 0 ; 0 0  mm3 ]  ; 
cc=[ 0  0 0 ; 0  0  0 ; 0 0  0 ] ; 
kk=[ kk1 -kk1 0 ; -kk1 kk1+kk2 -kk2 ; 0 -kk2 kk2 ] ; 
x0 = [ 1 -1  0 ]' ;
y0 = [ 0 0 1 ]' ;
tmax= 10 ; 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%       solution analytique     %%%%%%%%%%%%
z3 = [  0  0 0 ; 0  0  0 ; 0 0  0 ] ; 
I3 = [  1  0 0 ; 0  1  0 ; 0 0  1 ] ; 
aa = [ z3 , I3 ; -mm\kk , z3  ] ;  
u0 = [ x0 ; y0 ] ; 
uf = expm(tmax*aa)*u0 ; 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%       solution numerique     %%%%%%%%%%%%
n=100

dt=tmax/n ; 
t=zeros(1,n+1);
td=zeros(1,n);
x=zeros(3,n+1);
y=zeros(3,n+1); 

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%       solution numerique     %%%%%%%%%%%%
x(:,1:1) = x0 ; 
y(:,1:1) = y0 ; 
xx = x0 ;
yy = y0 ;
ga = -mm \ (cc * yy + kk*xx)  ;
ss = mm + .5*dt*cc + .25*dt*dt*kk ; 
for i=1:n;
t(i+1)=t(i)+dt;
td(1,i:i) = (i-.5)*dt ; 
end ; 
for i=1:n;
xt = xx + dt*yy + .25*dt*dt*ga ; 
yt = yy + .5*dt * ga ; 
ga = ss \ ( - kk*xt - cc*yt ) ;
xn = xt + .25*dt*dt*ga ; 
yn = yt + .5*dt*ga ; 
%
x(:,i+1:i+1) = xn(:,1) ; 
y(:,i+1:i+1) = yn(:,1) ; 
xx(:,1) = x(:,i+1:i+1) ; 
yy(:,1) = y(:,i+1:i+1) ; 
end ;

%%% uuu=zeros(6,n+1); 
%%% for i=1:n+1;
%%% uuu(:,i:i)  = expm(t(i)*aa)*u0 ; end 

xex=zeros(3,n+1);
yex=zeros(3,n+1); 

for i=1:n+1;
ttt = t(i) ; 
ut = expm(ttt*aa)*u0 ;
xex(1,i:i) = ut(1) ; xex(2,i:i) = ut(2) ; xex(3,i:i) = ut(3) ;
yex(1,i:i) = ut(4) ; yex(2,i:i) = ut(5) ; yex(3,i:i) = ut(6) ;
end 

xmax=tmax+.1 ; 
plot(t(1,:) , x(1:1,:), '*k;x1 position;' , t(1,:) , xex(1:1,:), 'k;;'  , ... 
     t(1,:) , x(2:2,:), '*b;x2 position;' , t(1,:) , xex(2:2,:), 'b;;'  , ...
     t(1,:) , x(3:3,:), '*r;x3 position;' , t(1,:) , xex(3:3,:),  'r;;' , ....
     t(1,:) , y(1:1,:), 'ok;y1 impulsion;' , t(1,:) , yex(1:1,:), 'k;;' , ...
     t(1,:) , y(2:2,:), 'ob;y2 impulsion;' , t(1,:) , yex(2:2,:), 'b;;' , ...
     t(1,:) , y(3:3,:), 'or;y3 impulsion;' , t(1,:) , yex(3:3,:), 'r;;') 
axis ( [ -.1   , xmax  , -1.9 , 6.1 ]) ; 
title ('triple oscillateur harmonique non amorti ; schema de Newmark ; solution cible') ; 
print('08a-solution-cible-newmark.jpg', '-djpg', '-S891,630'); 
pause (2) 


%%%%%%%%%%%               initialisation du processus d assimilation 
masse=mm ; amort=cc; kka1 = .5 ; kka2 = 3 ; 
raideur=[ kka1 -kka1 0 ; -kka1 kka1+kka2 -kka2 ; 0 -kka2 kka2 ] ; 
xxs=zeros(3,n+1);
yys=zeros(3,n+1); 


xxx = x0 ;
yyy = y0 ; 
xxs(:,1:1)=xxx ; 
yys(:,1:1)=yyy ; 
ssiter = masse + .5*dt*amort + .25*dt*dt*raideur ; 
for i=1:n;
ga = -masse \ ( raideur*xxx + amort*yyy )  ;
xt = xxx + dt*yyy + .25*dt*dt*ga ;
yt = yyy + .5*dt * ga ; 
ga = ssiter \ ( - raideur*xt - amort*yt ) ;
xxs(:,i+1:i+1)  = xt + .25*dt*dt*ga ; 
yys(:,i+1:i+1)  = yt + .5*dt*ga ; 
end ; 

err = xxs - x ; 
plot ( t(1,:) , err(1:1,:), '*k;erreur;' , t(1,:) , err(2:2,:), '*b;;' , ...
       t(1,:) , err(3:3,:), '*r;;'   ) ; 
axis ( [ -.1   , tmax+ .1   , -5.7 , 1.7 ]) ;
title ('triple oscillateur harmonique non amorti ; erreur initiale ; schema de Newmark') ; 
print('08b-initialisation-gradient-newmark.jpg', '-djpg', '-S891,630'); 
pause (2)  


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%              equation adjointe
ss = masse + .5*dt*amort + .25*dt*dt*raideur ; 
pp = zeros(3,n); qq = pp ; 
pp(:,n:n) = .5 * dt * err(:,n+1:n+1) ; 
qq(:,n:n) = 0 ; 
ymax = abs(pp(:, n:n)) ; 
ymax = max (ymax(:),abs(qq(:,n:n))) ; 
for j = 1:n-1;
jj    = n-j ; 
ro    = -ss \ (.25*dt*dt*pp(:,jj+1:jj+1) + .5*dt*qq(:,jj+1:jj+1) ) ; 
pt    = pp(:,jj+1:jj+1) + raideur*ro ; 
qt    = qq(:,jj+1:jj+1) + amort*ro ; 
rot   = - masse \ (.25*dt*dt*pt + .5*dt*qt ) ;
pp(:,jj:jj) = pt + dt*err(:,jj+1:jj+1) + raideur*rot ; 
qq(:,jj:jj) = qt + dt*pt               + amort*rot ; 
ymax = max (ymax(:),abs(pp(:,jj:jj))) ; 
ymax = max (ymax(:),abs(qq(:,jj:jj))) ; 
end ;

ymax = max(ymax(:)) ; ymax = 1.05 * ymax ;
plot (  td(1,:) , pp(1:1,:), '*k;pp1 premier etat adjoint;',   ... 
        td(1,:) , qq(1:1,:), 'ok;qq1 premier etat adjoint;'  ,  ...
        td(1,:) , pp(2:2,:), '*b;pp2 second etat adjoint;' , ...
        td(1,:) , qq(2:2,:), 'ob;qq2 second etat adjoint;' ,  ...
        td(1,:) , pp(3:3,:), '*r;pp3 troisieme etat adjoint;' , ...
        td(1,:) , qq(3:3,:), 'or;qq3 troisieme etat adjoint;' ) ; 
axis ( [ -.1   , tmax+.3  , -ymax  , 45  ] ) ;
title ('triple oscillateur harmonique non amorti ; etat adjoint pour l erreur initiale') ; 
print('08c-premiere-dynamique-etat-adjoint.jpg', '-djpg', '-S891,630'); 





