% ressort10.m
% fd  6 avril 2005, 08 janvier 2006, 09, 10 mars, 13 mai 2006 
%     19 juin  2006, 02 mars 2025 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% title ('triple oscillateur avec source sinusoidale') ;
mm1 = 1 ; mm2 = 1 ; mm3 = 1 ;  kk1 = 1 ; kk2 = 2 ; 
mm=[ mm1 0 0 ; 0  mm2 0 ; 0 0  mm3 ]  ; 
cc=[ 0  0 0 ; 0  0  0 ; 0 0  0 ] ; 
kk=[ kk1 -kk1 0 ; -kk1 kk1+kk2 -kk2 ; 0 -kk2 kk2 ] ; 
x0 = [ 1 ; -1 ;  0 ] ;
y0 = [ 0 ; 0 ; 1 ]  ;
tmax=  15.787 ; 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%       solution analytique     %%%%%%%%%%%%
z3 = [  0  0 0 ; 0  0  0 ; 0 0  0 ] ; 
I3 = [  1  0 0 ; 0  1  0 ; 0 0  1 ] ; 
I6 = [  I3  z3 ; z3   I3 ] ; 
aa = [ z3 , I3 ; -mm\kk , z3  ] ;  
u0 = [ x0 ; y0 ] ; 
charge =  [ 1 ; 0 ; -1 ] ; 
%   charge =  [ 0 ; 0 ;  0 ] ; 
phi   = [ 0 ; 0 ; 0 ; mm\charge ] ; 
omeg  = 4*pi ;  
psi2  = -( omeg*I6 + (1/omeg)*aa*aa ) \ phi ;  
psi1  = (1/omeg)*aa*psi2 ; 
uf    = sin(omeg*tmax)*psi1  +  cos(omeg*tmax)*psi2  + expm(tmax*aa)*(u0-psi2) ; 
dtuf  = omeg*cos(omeg*tmax)*psi1  -omeg*sin(omeg*tmax)*psi2  + aa*expm(tmax*aa)*(u0-psi2) ; 
resi =  dtuf - aa*uf - sin(omeg*tmax)*phi ; 
  
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%       solution numerique     %%%%%%%%%%%%
m=7
pas=zeros(m,1);
err=zeros(m,1);
%
n=32

for j=1:m;
dt=tmax/n ; 
t=zeros(1,n+1);
x=zeros(3,n+1);
y=zeros(3,n+1); 

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%       solution numerique     %%%%%%%%%%%%
for i=1:n;
t(1,i+1:i+1)=t(1,i:i)+dt;
end ; 
%
ff = t(1) * charge ; 
xx = x0 ;
yy = y0 ;
x(:,1:1) = xx(:,1) ; 
y(:,1:1) = yy(:,1) ; 
ga = mm \ ( ff - cc*yy - kk*xx )  ;
ss = mm + .5*dt*cc + .25*dt*dt*kk ; 
%
for i=1:n;
xt = xx + dt*yy + .25*dt*dt*ga ; 
yt = yy + .5*dt * ga ; 
ff = sin (omeg*t(1,i+1:i+1)) * charge ; 
ga = ss \ ( - kk*xt - cc*yt + ff ) ;
xn = xt + .25*dt*dt*ga ; 
yn = yt + .5*dt*ga ; 
%
x(:,i+1:i+1) = xn(:,1) ; 
y(:,i+1:i+1) = yn(:,1) ; 
xx(:,1) = x(:,i+1:i+1) ; 
yy(:,1) = y(:,i+1:i+1) ; 
% ga1 = mm \ ( ff - cc * yy - kk*xx )  
end ;
xmax=tmax+.1 ; 
axis ( [ -.1   , xmax  , -10.1 , 10.1 ]) ;

xexact=zeros(6,n+1);
for i=1:n+1;
xexact(:,i) = sin(omeg*t(1,i:i))*psi1  +  cos(omeg*t(1,i:i))*psi2  + ...
expm(t(1,i:i)*aa)*(u0-psi2) ; 
end ;

hold off 
if n==32 ;
plot(t(1,:) , x(1:1,:), '*k;x1 position;' , t(1,:) , xexact(1:1,:), 'k;;'  , ... 
     t(1,:) , x(2:2,:), '*b;x2 position;' , t(1,:) , xexact(2:2,:), 'b;;'  , ...
     t(1,:) , x(3:3,:), '*r;x3 position;' , t(1,:) , xexact(3:3,:),  'r;;' ) 
axis ( [ -.1   , xmax  , -1.2 , 7.9 ]) ;
title ('triple oscillateur harmonique avec source sinusoidale ; schema de Newmark, n=32') ;
print('10-032-iterations-newmark.jpg', '-djpg', '-S891,630'); pause (1) ; end

if n==64 ;
plot(t(1,:) , x(1:1,:), '*k;x1 position;' , t(1,:) , xexact(1:1,:), 'k;;'  , ... 
     t(1,:) , x(2:2,:), '*b;x2 position;' , t(1,:) , xexact(2:2,:), 'b;;'  , ...
     t(1,:) , x(3:3,:), '*r;x3 position;' , t(1,:) , xexact(3:3,:),  'r;;' ) 
axis ( [ -.1   , xmax  , -1.2 , 7.9 ]) ;
title ('triple oscillateur harmonique avec source sinusoidale ; schema de Newmark, n=64') ;
print('10-064-iterations-newmark.jpg', '-djpg', '-S891,630'); pause (1) ; end


if n==128 ;
plot(t(1,:) , x(1:1,:), '*k;x1 position;' , t(1,:) , xexact(1:1,:), 'k;;'  , ... 
     t(1,:) , x(2:2,:), '*b;x2 position;' , t(1,:) , xexact(2:2,:), 'b;;'  , ...
     t(1,:) , x(3:3,:), '*r;x3 position;' , t(1,:) , xexact(3:3,:),  'r;;' ) 
axis ( [ -.1   , xmax  , -1.2 , 7.9 ]) ;
title ('triple oscillateur harmonique avec source sinusoidale ; schema de Newmark, n=128') ;
print('10-128-iterations-newmark.jpg', '-djpg', '-S891,630'); pause (1) ; end


if n>=129 ;
plot(t(1,:) , x(1:1,:), '*k;x1 position;' , t(1,:) , xexact(1:1,:), 'k;;'  , ... 
     t(1,:) , x(2:2,:), '*b;x2 position;' , t(1,:) , xexact(2:2,:), 'b;;'  , ...
     t(1,:) , x(3:3,:), '*r;x3 position;' , t(1,:) , xexact(3:3,:),  'r;;' ) 
axis ( [ -.1   , xmax  , -1.2 , 7.9 ]) ;
title ('triple oscillateur harmonique avec source sinusoidale ; schema de Newmark') ;
pause (1) ; end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%                       erreur
pas(j:j,1)=n ; 
err(j:j,1)=log ( abs( x(1:1,n+1:n+1) - uf(1:1,1) ) + ... 
 abs( x(2:2,n+1:n+1) - uf(2:2,1) ) +  abs( x(3:3,n+1:n+1) - uf(3:3,1) )  ) / log(2)  ;
n=2*n 
end 



xxxx=zeros(m,1); xxxx =log(pas(:,1)) / log(2) ;
yyyy=zeros(m,1); yyyy = err(:,1) ;
     xmax= m+4 +.1 ; 
plot( xxxx , yyyy ,'*;logarithme des ereurs;') ;
axis ([ 4.9 ,  xmax  ,  -11.1 , 2.3 ]) ;
print('10-convergence-en-maillage-newmark.jpg', '-djpg', '-S891,630');


%               moindres carres
alpha = codre (m,xxxx,yyyy) 








